import processing.serial.*;

import processing.video.*;

Movie myMovie1;
MovieMaker mm;

import JMyron.*;
JMyron m;//a camera object

int counter = 0;
int mode = 1; // mode 1 = before start /// mode 2 = load /// mode 3 = recording /// mode 4 = showing/// 
int s = millis();
int recordTime = (5); //in seconds

int recording = 0;

int xspacing = 1;   // How far apart should each horizontal location be spaced
int w;              // Width of entire wave
int maxwaves = 2;   // total # of waves to add together

float theta = 0.0f;
float[] amplitude = new float[maxwaves];   // Height of wave
float[] dx = new float[maxwaves];          // Value for incrementing X, to be calculated as a function of period and xspacing
float[] yvalues;    // Using an array to store height values for the wave (not entirely necessary)


float a = 0.0;
float inc = TWO_PI/2;

//onda seconda
int xspacingA = 2;   // How far apart should each horizontal location be spaced
int wA;              // Width of entire wave
int maxwavesA = 2;   // total # of waves to add together

float thetaA = 0.0f;
float[] amplitudeA = new float[maxwavesA];   // Height of wave
float[] dxA = new float[maxwavesA];          // Value for incrementing X, to be calculated as a function of period and xspacing
float[] yvaluesA;    // Using an array to store height values for the wave (not entirely necessary)

float aA = 0.0;
float incA = TWO_PI/2;


Serial port;  // create serial port object 
int val;      // variable to receive data from the serial port

void setup() {
  port = new Serial(this, Serial.list()[1], 9600); 
  size(352, 288);
  m = new JMyron();
  m.start(width,height);
  m.findGlobs(0);


  //frameRate(100);
  smooth();
  w = width+25;
  wA = width+16;

  for (int i = 0; i < maxwaves; i++) {
    amplitude[i] =random(2,5);
    float period = random(100,300); // How many pixels before the wave repeats
    dx[i] = (TWO_PI / period) * xspacing;
  }
  for (int b = 0; b < maxwavesA; b++) {
    amplitudeA[b] =random(2,5);
    float periodA = random(100,400); // How many pixels before the wave repeats
    dxA[b] = (TWO_PI / periodA) * xspacingA;
  }
  yvalues = new float[w/xspacing];
  yvaluesA = new float[wA/xspacingA];
}

void draw() {


  switch(mode) {
  case 1: //mode 1 = before start 

    if( 0 < port.available()){  // if data is available to read 
      val = port.read();        // read it and store it in 'val' 
    } 
    println("val" +"   " +val);


    if (val == 49){// look for an input and then swap to mode 2
      mode = 2;
    } 
    else{
      val = 0;
    };
    break;


  case 2: //mode 2 = load 
    counter++;
    println("mode" +"   " +mode);

    loadPixels();
    mm = new MovieMaker(this,width,height,(counter + "prova1.mov"),MovieMaker.JPEG,MovieMaker.HIGH,16);
    mode = 3;
    s = millis() + (recordTime * 1000);
    recording = 1;
    break;


  case 3: /// mode 3 = recording 
    if (recording == 1){

      println("recording......   "+ m);
      val = 0;
      m.update();//update the camera view
      m.imageCopy(pixels);//draw image to stage
      updatePixels();
      filter(THRESHOLD);
      mm.add(); 


      if(millis() > s){
        mode = 4;
        mm.stop();
        println("in mode " + mode);
        //frameRate(30);
        myMovie1 = new Movie(this, (counter + "prova1.mov"));
        myMovie1.speed(1);
        myMovie1.frameRate(12);
        myMovie1.play();
      
        s = millis() + (recordTime * 1000);

      }
    }
    break;
  case 4: /// mode 4 = showing
    recording = 0;
    if ( myMovie1.time() >= myMovie1.duration()){
      myMovie1.speed(-1);

      myMovie1.jump(myMovie1.time() - 0.1);
      myMovie1.play();

    }
    if ( myMovie1.time() <= 0){
      myMovie1.jump(0.1);
      myMovie1.speed(1);
      myMovie1.play();

    }

    image(myMovie1, 0, 0); 

    for (int i=0; i<(width); i++) {

      for(int j=0; j<(height); j++) {

        color cp = get(i, j);
        if (brightness(cp) < 50){

          color c = color(0, 0,100);
          set(i, j, c);
        }

      }
    }


    if( 0 < port.available()){  // if data is available to read 
      val = port.read();        // read it and store it in 'val'

    } 
    else{
      val = 0;
    };
    println("playing...... " + mode +"  input is " +val);

    if(millis() > s){
      if (val == 49){// look for an input and then swap to mode 2
        mode = 2;
      }
    }
    break;
    
  }
  calcWave();
  renderWave();
  renderWaveA();

}

  // Called every time a new frame is available to read
  void movieEvent(Movie m) {
    m.read();
  }

void captureEvent(Capture myCapture) {
  myCapture.read();
}
void calcWave() {
  // Increment theta (try different values for 'angular velocity' here
  // theta += 0.02;
  theta += 0.1;
  thetaA += 0.2;

  // Set all height values to zero
  for (int i = 0; i < yvalues.length; i++) {
    yvalues[i] = 0.0f;
  }
  for (int b = 0; b < yvaluesA.length; b++) {
    yvaluesA[b] = 0.0f;
  }

  // Accumulate wave height values
  for (int j = 0; j < maxwaves; j++) {
    float x = theta;
    for (int i = 0; i < yvalues.length; i++) {
      // Every other wave is cosine instead of sine
      if (j % 2 == 0)  yvalues[i] += sin(x)*amplitude[j];
      else yvalues[i] += cos(x)*amplitude[j];
      x+=dx[j];
    }
  }
  for (int g = 0; g < maxwavesA; g++) {
    float v = thetaA;
    for (int b= 0; b < yvaluesA.length; b++) {
      // Every other wave is cosine instead of sine
      if (g % 2 == 0)  yvaluesA[b] += sin(v)*amplitudeA[g];
      else yvaluesA[b] += cos(v)*amplitudeA[g];
      v+=dxA[g];
    }
  }
}

void renderWave() {

  stroke(39,157,105,90);

  for (int x = 0; x < yvalues.length; x++) {
    line(x*xspacing,width/2+yvalues[x],x*xspacing,288);
  }
}
void renderWaveA() {  
  stroke(255,127,0);

  for (int v = 0; v < yvaluesA.length; v++) {
    point(v*xspacingA,230+yvaluesA[v]);
  }
}

void mousePressed(){
  m.settings();//click the window to get the settings
}
